--Circle(x, y, diameter) -- circle
--Line( x1, y1, x2, y2) -- Line from X1, Y1 to X2, Y2
--MoveTo( x, y) -- Set Current Position
--LineTo(x , y) -- Line from current position to X, Y.
--ArcA(startX, startY, CentreX, centreY, angle) -- angle in Radians, Positive Angle Clockwise

-- line with zero length = "point"

-- SHAPE NAME: TRAPEZOID

shape = {}

function shape.Calculate()
	Line(0,0,shape.base,0)
	Line(shape.base,0,shape.base+shape.rightoffset,shape.rightheight)
	Line(shape.base+shape.rightoffset,shape.rightheight,0+shape.leftoffset,shape.leftheight)
	Line(0+shape.leftoffset,shape.leftheight,0,0)  
   end

AddNumControl("base", "Base", sc.unitLINEAR, 100, 0.1, 10000, "base.png")
AddNumControl("leftheight", "Altura izquierda", sc.unitLINEAR, 150, 0.1, 10000, "leftheight.png")
AddNumControl("rightheight", "Altura derecha", sc.unitLINEAR, 100, 0.1, 10000, "rightheight.png")
AddNumControl("leftoffset", "Compensacion izquierda", sc.unitLINEAR, 0, -10000, 10000, "leftoffset.png")
AddNumControl("rightoffset", "Compensacion derecha", sc.unitLINEAR, 25, -10000, 10000, "rightoffset.png")
