--Circle(x, y, diameter) -- circle
--Line( x1, y1, x2, y2) -- Line from X1, Y1 to X2, Y2
--MoveTo( x, y) -- Set Current Position
--LineTo(x , y) -- Line from current position to X, Y.
--ArcA(startX, startY, CentreX, centreY, angle) -- angle in Radians, Positive Angle Clockwise

-- line with zero length = "point"

-- SHAPE NAME: Straight Lug

shape = {}

function shape.Calculate()
   local hw = shape.width / 2
   local hh = shape.height / 2
   local d = shape.diameter
    MoveTo(0,0)
	Line(-hw, hh, -hw, -hh)
    Line(-hw, -hh, hw, -hh)
	Line(hw, -hh, hw, hh)
	ArcA(hw, hh, 0, hh, -math.pi)
	Circle(0, hh, d)
	   
   end

AddNumControl("width", "Ancho", sc.unitLINEAR, 100, 0.1, 10000, "width.png")
AddNumControl("height", "Altura", sc.unitLINEAR, 150, 0.1, 10000, "height.png")
AddNumControl("diameter", "Diametro", sc.unitLINEAR, 50, 0.1, 10000, "diameter.png")
